<template>
  <div
    v-if="countDown !== 'Время вышло'"
    class="account-controls"
  >
    <div class="account-controls-count">
      <div class="account-controls-count--block">
        <div
            class="account-controls-count--block-item"
            :class="{ 'disabled': minDisabled }"
            @click="onMinus"
        >
          <span>-</span>
        </div>
        
        <div class="account-controls-count--block-value">
          {{ currentPrice.priceWithVat / 100 | currency }}
        </div>

        <div
            class="account-controls-count--block-item"
            :class="{ 'disabled': maxDisabled }"
            @click="onPlus"
        >
          <span>+</span>
        </div>
      </div>
    </div>
    <div class="account-controls-button">
      <ob-button
          @click="makeBidWrapper"
          :label="order.currentState === STEP.NO_BIDS ? 'Сделать ставку' : 'Обновить ставку'"
          :disabled="buttonRate"
          class="account-button"
      />
    </div>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex'
  import ObButton from 'common-components/src/obComponents/obButton'
  import STEPS from '@/constants/steps.js'
  import accountTimerMixin from '@/mixins/account-timer-mixin.js'

  export default {
    name: "Counter",
    mixins: [ accountTimerMixin ],
    components: {
      ObButton
    },
    props: {
      indicators: {
        type: Object,
        default: () => {}
      }
    },
    data() {
      return {
        currentPrice: {
          priceWithoutVat: 0,
          priceWithVat: 0,
          vatValue: 0
        },
        STEP: STEPS
      }
    },
    computed: {
      ...mapGetters({
        order: 'account/order',
        buttonRate: 'account/buttonRate',
        vat: 'account/vat',
        vatRate: 'account/vatRate'
      }),
      bidsCount () {
        return this.order.bidsCount
      },
      minDisabled () {
        if (this.countDown === 'Время вышло') {
          return true
        }
        return this.currentPrice.priceWithoutVat - this.order.biddingStepAmount?.priceWithoutVat <= 0
      },
      maxDisabled () {
        if (this.countDown === 'Время вышло') {
          return true
        }
        if (this.bidsCount) {
          return this.currentPrice.priceWithoutVat + this.order.biddingStepAmount?.priceWithoutVat >= this.order.totalPrice
        } else {
          return this.currentPrice.priceWithoutVat + this.order.biddingStepAmount?.priceWithoutVat > this.order.totalPrice
        }
      }
    },
    watch: {
      'order.totalPrice': {
        immediate: true,
        handler () {
          const { totalPriceAmount, bidsCount, biddingStepAmount } = this.order
          const isSubtract = Boolean(bidsCount) && (totalPriceAmount.priceWithoutVat - biddingStepAmount.priceWithoutVat) > 0

          this.currentPrice = {
            priceWithoutVat: isSubtract ? totalPriceAmount.priceWithoutVat - biddingStepAmount.priceWithoutVat : totalPriceAmount.priceWithoutVat,
            priceWithVat: isSubtract ? totalPriceAmount.priceWithVat - biddingStepAmount.priceWithVat : totalPriceAmount.priceWithVat,
            vatValue: isSubtract ? totalPriceAmount.vatValue - biddingStepAmount.vatValue : totalPriceAmount.vatValue,
          }
        }
      }
    },
    mounted() {
      setInterval(() => this.countDownTimer(this.indicators.completionDt), 1000)
      this.countDownTimer(this.order.completionDt)
    },
    methods: {
      ...mapActions({
        makeBid: 'account/makeBid'
      }),
      async makeBidWrapper() {
        await this.makeBid({ bid: this.currentPrice.priceWithoutVat, lotUuid: this.order.uuid })
        if (!this.minDisabled) {
          this.onMinus()
        }
      },
      onMinus () {
        const { biddingStepAmount } = this.order
        this.currentPrice = {
          priceWithoutVat: this.currentPrice.priceWithoutVat - biddingStepAmount.priceWithoutVat,
          priceWithVat: this.currentPrice.priceWithVat - biddingStepAmount.priceWithVat,
          vatValue: this.currentPrice.vatValue - biddingStepAmount.vatValue
        }
      },
      onPlus () {
        const { biddingStepAmount } = this.order
        this.currentPrice = {
          priceWithoutVat: this.currentPrice.priceWithoutVat + biddingStepAmount.priceWithoutVat,
          priceWithVat: this.currentPrice.priceWithVat + biddingStepAmount.priceWithVat,
          vatValue: this.currentPrice.vatValue + biddingStepAmount.vatValue
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  .account-controls {
    padding: 20px 20px 0;
    &-count {
      display: flex;
      justify-content: center;
      width: 100%;

      &--block {
        display: flex;
        justify-content: space-between;
        margin-bottom: 20px;

        &-item {
          width: 40px;
          height: 40px;
          display: flex;
          justify-content: center;
          align-items: center;
          color: $color-blue-navy-blue;
          border: 2px solid $color-blue-navy-blue;
          border-radius: 10px;
          cursor: pointer;
          span {
            font-size: 22px;
          }
          &.disabled {
            pointer-events: none;
            color: $gray-window;
            border: 1px solid $gray-window;
          }
        }

        &-value {
          font-size: 16px;
          line-height: 20px;
          letter-spacing: 0.2px;
          color: $color-text-base;
          margin: 10px 0;
          width: 94px;
          text-align: center;
        }
      }
    }
    &-button {
      display: flex;
      justify-content: center;
    }
  }
</style>